#!/usr/bin/env perl

# (C) Copyright 2003 Krzysztof Gibas <sdas (at) gibas org>
#
# This script renames logs from format: 
#               ipfm-global-03-01-01.log to ipfm-global-2003-01-01.log
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This  program is  distributed in the  hope  that  it will be useful,
# but  WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of
# MERCHANTABILITY  or  FITNESS  FOR  A  PARTICULAR  PURPOSE.  See  the
# GNU General Public License for more details.
# 
# You  should  have  received a copy of the GNU General Public License
# along  with  this  program;  if  not,  write  to  the  Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
# USA.
#
# $Id: ipfm_renamelogs.pl,v 1.7 2003/10/15 19:27:26 gibas Exp $

use strict;
use warnings;

my ($filename, $new_filename, @split);

if (@ARGV < 1 || @ARGV > 1) {
    print ".----------------------------------------------------------.\n";
    print "| $0                                     |\n";
    print "| Copyright (C) 2003 Krzysztof Gibas <sdas (at) gibas org> |\n";
    print "`----------------------------------------------------------'\n";
    print "\nUsage: $0 [directory]\n\n";
    exit();
}

opendir(DIRHANDLE, "$ARGV[0]") or die "Error $ARGV[0]: $!\n";
    while ( defined ($filename = readdir(DIRHANDLE)) ) {
        if ($filename =~ /^ipfm-global-\d\d-\d\d-\d\d\.log$/) {
            @split = split(/-/, $filename);
            $new_filename = "$split[0]-$split[1]-20" . $split[2] . "-$split[3]-$split[4]";
            rename ("$ARGV[0]/$filename", "$ARGV[0]/$new_filename") || die "Error: $!\n";
        }
    }
closedir(DIRHANDLE);
